%define quagga_user	quagga
%define quagga_uid	115	
%define quagga_gid	115
%define vty_group	quaggavt
%define daemons_min	bgpd isisd ripd ospfd zebra watchquagga
%define daemons_all      %{daemons_min} ripngd ospf6d

Summary: Routing daemon
Name: quagga
Version: 0.99.9
Release: 1tr
License: GPL
Group: Trustix Official
Source0: http://www.quagga.net/download/%{name}-%{version}.tar.gz
Source1: bgpd.init
Source2: isisd.init
Source3: ripd.init
Source4: ripngd.init
Source5: ospfd.init
Source6: ospf6d.init
Source7: zebra.init
Source8: watchquagga.init
Source9: quagga.pam
Source10: quagga.sysconfig
Source11: quagga.logrotate
Source12: zebra.conf
Source13: vtysh.conf
Source14: quagga-0.98.5-perlreqexclude.sh
URL: http://www.quagga.net
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Prereq:		net-snmp ncurses
BuildRequires:	readline-devel ncurses-devel net-snmp-devel
BuildRequires:	texinfo pam-devel patch libcap-devel

# Default pid should be in /var/run/%{name}
%{expand: %%define _localstatedir %{_localstatedir}/run/%{name}}
# Auto-generated perl.req which need to be excluded
%define __perl_requires %{SOURCE14}

%description
Quagga is a free software that manages TCP/IP based routing
protocol. It takes multi-server and multi-thread approach to resolve
the current complexity of the Internet.

Quagga supports BGP4, BGP4+, OSPFv2, OSPFv3, RIPv1, RIPv2, and RIPng.

Quagga is intended to be used as a Route Server and a Route Reflector.
It is not a toolkit, it provides full routing power under a new
architecture. Quagga by design has a process for each protocol.

Quagga is a fork of GNU Zebra.

%package contrib
Summary: contrib tools for quagga
Group: Trustix Official

%description contrib
Contributed/3rd party tools which may be of use with quagga.

%package devel
Summary: Header and object files for quagga development
Group: Trustix Official

%description devel
The quagga-devel package contains the header and object files neccessary for
developing OSPF-API and quagga applications.

%prep
%setup  -q

%build
export CXXFLAGS="$RPM_OPT_FLAGS"
CFLAGS="$RPM_OPT_FLAGS" %configure  \
	--enable-ipv6 \
	--with-cflags="-O2" \
	--enable-snmp \
	--enable-tcp-zebra \
	--enable-nssa \
	--enable-opaque-lsa \
	--enable-ospf-te \
	--enable-vtysh \
	--enable-ospfclient=yes \
	--enable-ospfapi=yes \
	--with-libpam \
	--enable-user=%{quagga_user} \
	--enable-group=%{quagga_user} \
	--enable-vty-group=%{vty_group} \
	--enable-rtadv \
	--enable-netlink
%__make 

%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT%{_sysconfdir}/{quagga,init.d}
install -d $RPM_BUILD_ROOT%{_sysconfdir}/{sysconfig,logrotate.d,pam.d} \
	$RPM_BUILD_ROOT/var/log/quagga
install -d -m770  $RPM_BUILD_ROOT/var/run/%{name}

make DESTDIR=$RPM_BUILD_ROOT install

# install the init
install -m755 %SOURCE1 $RPM_BUILD_ROOT%{_initdir}/bgpd
install -m755 %SOURCE2 $RPM_BUILD_ROOT%{_initdir}/isisd
install -m755 %SOURCE3 $RPM_BUILD_ROOT%{_initdir}/ripd
install -m755 %SOURCE4 $RPM_BUILD_ROOT%{_initdir}/ripngd
install -m755 %SOURCE5 $RPM_BUILD_ROOT%{_initdir}/ospfd
install -m755 %SOURCE6 $RPM_BUILD_ROOT%{_initdir}/ospf6d
install -m755 %SOURCE7 $RPM_BUILD_ROOT%{_initdir}/zebra
install -m755 %SOURCE8 $RPM_BUILD_ROOT%{_initdir}/watchquagga

# install the sysconfdir
install -m755 %SOURCE9 $RPM_BUILD_ROOT%{_sysconfdir}/pam.d/%{name}
install -m755 %SOURCE10 $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/%{name}
install -m755 %SOURCE11 $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/%{name}

# Remove these from sysconfdir
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/*.conf.sample*
rm -f $RPM_BUILD_ROOT%{_datadir}/info/quagga.info.gz

install -m640 %SOURCE12 $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/zebra.conf
install -m640 %SOURCE13 $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/vtysh.conf

%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT

%pre
# add vty_group
if ! getent group %{vty_group} >/dev/null; then
  /usr/sbin/groupadd -r %{vty_group} 2> /dev/null || :
fi
# add quagga user and group
if ! getent group %{quagga_user} >/dev/null; then
  /usr/sbin/groupadd -r -g %{quagga_gid} %{quagga_user} 2> /dev/null || : 	
fi
if ! getent passwd %{quagga_user} >/dev/null; then
/usr/sbin/useradd  -u %{quagga_uid} -g %{quagga_gid} \
  -M -r -s /sbin/nologin -d /var/run/quagga %{quagga_user} 2> /dev/null || :
fi

%post
if [ "$1" = "2" ]; then
	for daemon in %{daemons_all}  ; do
  	/sbin/restart_maybe $daemon
	done
fi
for daemon in %{daemons_all}  ; do
        /sbin/chkconfig --add $daemon
done

%preun
if [ "$1" = "0" ]; then
   for daemon in %{daemons_all}  ; do
	%{_initdir}/$daemon stop >&2
    	/sbin/chkconfig --del $daemon
   done
fi

%files
%defattr(-,root,root,0755)
%doc */*conf.sample* AUTHORS COPYING doc/mpls
%doc ChangeLog INSTALL NEWS README REPORTING-BUGS SERVICES TODO
%{_sbindir}/*
%{_bindir}/*
%{_libdir}/*.so*
%dir %attr(750,%quagga_user,%quagga_user) %{_sysconfdir}/%{name}
%dir %attr(770,%quagga_user,%quagga_user) /var/log/%{name} 
%dir %attr(770,%quagga_user,%quagga_user) /var/run/%{name}
%attr(750,%quagga_user,%vty_group) %{_sysconfdir}/%{name}/vtysh.conf
%attr(750,%quagga_user,%quagga_user) %{_sysconfdir}/%{name}/zebra.conf
%{_mandir}/man*/*
%config(noreplace) %{_sysconfdir}/%{name}/[!v][!z]*
%{_initdir}/*
%config(noreplace) /etc/pam.d/%{name}
%config(noreplace) %attr(640,root,root) /etc/logrotate.d/%{name}
%config(noreplace) /etc/sysconfig/%{name}                  
%exclude %{_datadir}/info/quagga.info.gz
%exclude %{_datadir}/info/quagga.info-1.gz
%exclude %{_datadir}/info/quagga.info-2.gz

%files contrib
%defattr(-,root,root,0755)
%doc tools

%files devel
%defattr(-,root,root,0755)
%{_libdir}/*.a
%{_libdir}/*.la
%{_includedir}/%{name}

%changelog
* Thu Sep 20 2007 Nived Gopalan <nived at trustix dot org> 0.99.9-1tr
- New Upstream.
- SECURITY Fix: A vulnerability have been reported in Quagga, caused
  due to bgpd improperly handling messages sent by peers. This can be
  exploited to crash bgpd by sending a specially crafted "OPEN"
  message with an invalid message length or an invalid parameter
  length, or a specially crafted "UPDATE" message with a malformed
  "COMMUNITY" attribute.

  The Common Vulnerabilities and Exposures project (cve.mitre.org)
  has assigned the name CVE-2007-4826 to this issue.

* Thu May 03 2007 Nived Gopalan <nived at trustix dot org> 0.99.7-1tr
- New Upstream.
- SECURITY Fix: Paul Jakma has reported a vulnerability in Quagga, 
  caused due to bgpd not checking the length information of the
  "MP_UNREACH_NLRI" and "MP_REACH_NLRI" attributes. This can be
  exploited to cause an assertion error or out of bounds read by
  sending a specially crafted UPDATE message.

  The Common Vulnerabilities and Exposures project (cve.mitre.org)
  has assigned the name CVE-2007-1995 to this issue.

* Mon Feb 26 2007 Nived Gopalan <nived at trustix dot org>
- Rebuilt

* Tue Jun 20 2006 Bipin S <bipin at trustix dot org> 0.99.4.-1tr
- Initial entry into TSL-3.0.5

* Tue May 23 2006 Nived Gopalan <nived at trustix dot org> 0.98.6-1tr
- New Upstream. 
- SECURITY Fix: Konstantin V. Gavrilenko has reported two security issues
  in Quagga, which can be exploited by malicious people to bypass certain
  security restrictions and to disclose system information.
- An error in RIPd does not properly implement configurations that 1) 
  disable RIPv1 or 2) require plaintext or MD5 authentication. This allows 
  remote attackers to obtain sensitive information via REQUEST packets 
  such as SEND UPDATE.
- An error in RIPd does not properly enforce RIPv2 authentication 
  requirements. This allows remote attackers to modify routing state via
  RIPv1 RESPONSE packets.
- Fredrik Widell has reported a vulnerability in Quagga caused due to an
  infinite loop error in bgpd within the "community_str2com()" function.
  This can be exploited to cause the process to consume large amounts of
  CPU resources by issuing the "sh ip bgp command" command via the telnet
  management interface.
 	
  The Common Vulnerabilities and Exposures project (cve.mitre.org) has
  assigned the names CVE-2006-2223, CVE-2006-2224 and CVE-2006-2276 to
  these issues.

* Tue Jan 17 2006 Ajith Thampi <ajith at trustix dot org> 0.98.5-2tr
- Rebuilt
		
* Tue Sep 20 2005 Ajith Thampi <ajith at comodo dot com> 0.98.5-1tr
- Initial Entry into TSL 3.0	
